#!/bin/sh

# defaults
project="demo"
tools="tools-macosx"
dasm="${tools}/dasm"
stella="${tools}/Stella.app/Contents/MacOS/Stella"

# optional parameter: alternative project name
if [ -n "${1}" ]; then
   project="${1}"
fi

# strip off eventual .asm extension
project="${project%.asm}"

# run assembler
echo "assemble: ${project}.asm -> ${project}.bin"
"${dasm}" ${project}.asm -f3 -o${project}.bin -s${project}.sym

# run emulator
echo "run: ${project}.bin"
"${stella}" ${project}.bin

