
   processor 6502
   include vcs.h

   seg.u $80
   org $80
pf1v:
   ds.b 2
pf2v:
   ds.b 2
framecount:
   ds.b 1

   seg
   org $f000
   rorg $f000

TIMER_VBLANK   = $2a ;  ~2688 cycles
TIMER_SCREEN   = $13 ; ~77824 cycles
TIMER_OVERSCAN = $14 ;  ~1280 cycles

; jumptable of demoparts
demoparts:
   dc.w invader,reset

; graphics data for PF2 frame A
gfx2a:
   dc.b %00000110
   dc.b %00011000
   dc.b %11111110
   dc.b %11100111
   dc.b %11111111
   dc.b %11111111
   dc.b %00000110
   dc.b %00000001

; graphics data for PF2 frame B
gfx2b:
   dc.b %00000110
   dc.b %00011000
   dc.b %11111110
   dc.b %11100111
   dc.b %11111111
   dc.b %11111110
   dc.b %00000110
   dc.b %01111000

; graphics data for PF1 frame A
gfx1a:
   dc.b %00000000
   dc.b %00000110
   dc.b %00000110
   dc.b %00000111
   dc.b %00000111
   dc.b %00000001
   dc.b %00000000
   dc.b %00000001

; graphics data for PF1 frame B
gfx1b:
   dc.b %00000000
   dc.b %00000000
   dc.b %00000000
   dc.b %00000001
   dc.b %00000111
   dc.b %00000110
   dc.b %00000110
   dc.b %00000000

; load in the framework code
   include framework.asm

; main code
invader:
   inc framecount   ; increment frame counter
   lda framecount   ; load frame counter
   and #$20         ; mask out one bit for detection of image to show
   bne .inv2        ; branch out to loading frame B data
   lda #<gfx1a      ; load graphics data for frame A to vectors
   sta pf1v+0       ; 
   lda #>gfx1a      ; 
   sta pf1v+1       ; 
   lda #<gfx2a      ; 
   sta pf2v+0       ; 
   lda #>gfx2a      ; 
   sta pf2v+1       ; 
   bne .show        ; 
.inv2:
   lda #<gfx1b      ; load graphics data for frame B to vectors
   sta pf1v+0       ; 
   lda #>gfx1b      ; 
   sta pf1v+1       ; 
   lda #<gfx2b      ; 
   sta pf2v+0       ; 
   lda #>gfx2b      ; 
   sta pf2v+1       ; 
.show:
   jsr waitvblank   ; wait for the vblank area to complete

   lda #$44         ; set playfield color to orange
   sta COLUPF       ; 
   lda #$01         ; set playfield configuration to mirrored
   sta CTRLPF       ; 

   ldx #$30         ; wait $30 (= 48) lines: load value to index register
.waitloop1:
   sta WSYNC        ; wait until start of next line
   dex              ; decrement index register
   bne .waitloop1   ; loop until index register is zero

   ldy #$00         ; set data index to $00 (=0)
.dataloop:
   ldx #$10         ; set lines counter to $10 (=16)
.waitloop2:
   sta WSYNC        ; wait until start of next line
   lda (pf1v),y     ; \ load graphics data for PF1
   sta PF1          ; / 
   lda (pf2v),y     ; \ load graphics data for PF2
   sta PF2          ; / write data
   dex              ; do the same for each of the 16 lines
   bne .waitloop2   ; 
   iny              ; increment data index
   cpy #$08         ; \ 
   bcc .dataloop    ; / loop while (y < 8)

   stx COLUPF       ; index register now is 0: set color to black
   stx PF1          ; clear out PF1
   stx PF2          ; clear out PF2

   jsr waitscreen   ; wait until screen area is finished
   jmp waitoverscan ; wait until overscan area is finished and run sync of
                    ; new frame

   VECTORS reset,reset
